<script lang="ts">
import Vue, { PropType } from 'vue';
import { CtfTheSourceAuthor } from '~/models';
import { getUrlFromContentfulImage } from '~/common/util';

export default Vue.extend({
  name: 'TheSourceAuthorHero',
  props: {
    author: {
      type: Object as PropType<CtfTheSourceAuthor>,
      required: true,
    },
  },
  computed: {
    headshot() {
      return getUrlFromContentfulImage(this.author.headshot);
    },
    gitlabHandle() {
      return `https://gitlab.com/${this.author.gitlabHandle}`;
    },
    hasSocialLinks() {
      return (
        this.author.threadsProfileUrl ||
        this.author.linkedInProfileUrl ||
        this.author.facebookProfileUrl ||
        this.author.twitterXProfileUrl ||
        this.author.hackerNewsProfileBlogUrl ||
        this.author.gitlabHandle
      );
    },
  },
});
</script>

<template>
  <section class="author-hero">
    <SlpContainer>
      <SlpTypography tag="h5" variant="all-caps" class="slp-mb-32"
        >{{ $t('articles.articlesBy') }}
      </SlpTypography>
      <div class="author-hero__main">
        <div class="author-hero__headshot">
          <img :src="headshot" />
        </div>
        <div
          :class="[
            'author-hero__details',
            { 'slp-align-items-center': !author.role },
          ]"
        >
          <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-8"
            >{{ author.name }}
          </SlpTypography>
          <SlpTypography tag="h5" variant="heading5-bold" class="slp-mb-8"
            >{{ author.role }}
          </SlpTypography>
        </div>
      </div>
      <SlpTypography
        tag="p"
        variant="body1"
        :class="{ 'slp-mb-32': hasSocialLinks }"
        >{{ author.bio }}
      </SlpTypography>
      <!-------- SOCIAL LINKS -------->
      <div v-if="hasSocialLinks" class="author-hero__social">
        <a
          v-if="author.gitlabHandle"
          :href="gitlabHandle"
          target="_blank"
          data-ga-name="gitlab"
          data-ga-location="body"
        >
          <SlpIcon name="gitlab" variant="marketing" />
        </a>
        <a
          v-if="author.linkedInProfileUrl"
          :href="author.linkedInProfileUrl"
          target="_blank"
          data-ga-name="linkedin"
          data-ga-location="body"
        >
          <SlpIcon name="linkedin" variant="marketing" />
        </a>
        <a
          v-if="author.twitterXProfileUrl"
          :href="author.twitterXProfileUrl"
          target="_blank"
          data-ga-name="twitter"
          data-ga-location="body"
        >
          <SlpIcon name="twitter-x" variant="marketing" />
        </a>
        <a
          v-if="author.facebookProfileUrl"
          :href="author.facebookProfileUrl"
          target="_blank"
          data-ga-name="facebook"
          data-ga-location="body"
        >
          <SlpIcon name="facebook" variant="marketing" />
        </a>
        <a
          v-if="author.hackerNewsProfileBlogUrl"
          :href="author.hackerNewsProfileBlogUrl"
          target="_blank"
          data-ga-name="hacker news"
          data-ga-location="body"
        >
          <SlpIcon name="hackernews" variant="marketing" />
        </a>
        <a
          v-if="author.threadsProfileUrl"
          :href="author.threadsProfileUrl"
          class="social-link"
          data-ga-name="threads"
          data-ga-location="body"
        >
          <SlpIcon color="#000" name="threads" variant="marketing" size="sm" />
        </a>
      </div>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.author-hero {
  padding: $spacing-32 0;
  background-color: $color-surface-100;

  @media (width >= $breakpoint-md) {
    padding: $spacing-32 0 $spacing-64 0;
  }

  &__main {
    display: flex;
    flex-direction: column;
    margin-bottom: $spacing-16;

    @media (width >= $breakpoint-md) {
      flex-direction: row;
    }
  }

  &__headshot {
    img {
      width: 124px;
      height: 124px;
      border-radius: 50%;
    }
  }

  &__details {
    display: flex;
    flex-direction: column;

    @media (width >= $breakpoint-md) {
      padding: 0 $spacing-24;
    }
  }

  &__social {
    display: flex;
    gap: $spacing-24;
    padding-top: $spacing-16;
    border-top: 1px solid $color-surface-300;

    .slp-icon {
      width: 24px !important;
      height: 24px !important;
    }
  }
}
</style>
